/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * RadicalInfoWindow.java
 *
 * Created on 21-nov-2010, 11:55:28
 */

package net.ajaest.jdk.gui.windows;

import java.util.SortedSet;

import net.ajaest.jdk.core.winHandlers.KanjiInfoWH;
import net.ajaest.jdk.data.kanji.Radical;
import net.ajaest.jdk.gui.auxi.RadicalInfoPanel;

/**
 *
 * @author ajaest10
 */
public class RadicalInfoWindow extends javax.swing.JFrame {

	private static final long serialVersionUID = -464969972456576351L;

	private KanjiInfoWH kiwe;
    private SortedSet<Radical> variants;

    /** Creates new form RadicalInfoWindow */
    public RadicalInfoWindow(KanjiInfoWH kiwe, SortedSet<Radical> radicals) {

        this.kiwe = kiwe;
        this.variants = radicals;
        
		this.setIconImages(kiwe.getIcons());

        StringBuilder title = new StringBuilder();

        Radical firstUnicode = null;
        for(Radical r : radicals){
            if(r.getUnicode()!=null){
                firstUnicode = r;
                break;
            }
        }

        if(firstUnicode!=null){
            title.append(new String(Character.toChars(firstUnicode.unicode)));
            title.append(" - ");
            title.append(firstUnicode.getRadicalNumber());
        }

        this.setTitle(title.toString());

        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        MainPanel = new javax.swing.JPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        MainPanel.setLayout(new java.awt.GridLayout(1, getColumsCount()));
        getContentPane().add(MainPanel, java.awt.BorderLayout.CENTER);
        for(Radical rad : variants){

            MainPanel.add(new RadicalInfoPanel(kiwe, rad, kiwe.getOptions().getRomanized()));
        }

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        kiwe.windowClosed(this);
    }//GEN-LAST:event_formWindowClosed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new RadicalInfoWindow(new KanjiInfoWH(null),null).setVisible(true);
            }
        });
    }

    private int getColumsCount(){

        return variants.size();
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel MainPanel;
    // End of variables declaration//GEN-END:variables

	public Integer getRadNumber() {

		return variants.first().radicalNumber;
	}
}
